/** 
 * @file lltexturestatsuploader.h
 * @brief Class to send the texture stats to the simulatore
 *
 * $LicenseInfo:firstyear=2009&license=viewerlgpl$
 * Second Life Viewer Source Code
 * Copyright (C) 2010, Linden Research, Inc.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License only.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 * Linden Research, Inc., 945 Battery Street, San Francisco, CA  94111  USA
 * $/LicenseInfo$
 */

#ifndef LL_LLTEXTURESTATSUPLOADER_H
#define LL_LLTEXTURESTATSUPLOADER_H

#include "llappviewer.h"

// utility functions to capture data on texture download speeds and send to simulator periodically

class LLTextureStatsUploader
{
public:
	LLTextureStatsUploader();
	~LLTextureStatsUploader();
	void uploadStatsToSimulator(const std::string texture_cap_url, const LLSD &texture_stats);
};

#endif // LL_LLTEXTURESTATSUPLOADER_H
